PrefabFiles = {
	"ancient_altar_sack",
	"ancient_altar_scrap_top",
	"ancient_altar_scrap_midleft",
	"ancient_altar_scrap_midright",
	"ancient_altar_scrap_dnleft",
	"ancient_altar_scrap_dnright",
}

Assets = {
	-- Asset("IMAGE", "images/inventory/AncientAltar.tex"),
	-- Asset("ATLAS", "images/inventory/AncientAltar.xml"),
	
	-- Asset("IMAGE", "images/inventory/AncientAltarScrapTop.tex"),
	-- Asset("ATLAS", "images/inventory/AncientAltarScrapTop.xml"),
	
	-- Asset("IMAGE", "images/inventory/AncientAltarScrapMidLeft.tex"),
	-- Asset("ATLAS", "images/inventory/AncientAltarScrapMidLeft.xml"),
	
	-- Asset("IMAGE", "images/inventory/AncientAltarScrapMidRight.tex"),
	-- Asset("ATLAS", "images/inventory/AncientAltarScrapMidRight.xml"),
	
	-- Asset("IMAGE", "images/inventory/AncientAltarScrapDnLeft.tex"),
	-- Asset("ATLAS", "images/inventory/AncientAltarScrapDnLeft.xml"),
	
	-- Asset("IMAGE", "images/inventory/AncientAltarScrapDnRight.tex"),
	-- Asset("ATLAS", "images/inventory/AncientAltarScrapDnRight.xml"),
}

local require = GLOBAL.require
local Tuning = GLOBAL.TUNING
local Recipe = GLOBAL.Recipe
local RecipeTabs = GLOBAL.RECIPETABS
local Tech = GLOBAL.TECH
local Strings = GLOBAL.STRINGS
local Ingredient = GLOBAL.Ingredient
local TheNet = GLOBAL.TheNet


GLOBAL.CRAFTABLEANCIENTALTAR_FORCELANGUAGE = GetModConfigData("forceLanguage")
print("Craftable Ancient Altar and Thulecite Pieces: Настройка forceLanguage = ", GLOBAL.CRAFTABLEANCIENTALTAR_FORCELANGUAGE)


-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_TOP = "Ancient Altar Top Scrap"
-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_TOP = "Ancient Altar Top Scrap."
-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_TOP = "Possibly it is top something ancient."

-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Ancient Altar Middle Left Scrap"
-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Ancient Altar Middle Left Scrap."
-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Hmmm... Probably it is some ancient wall."

-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Ancient Altar Middle Right Scrap"
-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Ancient Altar Middle Right Scrap."
-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Hmmm... Probably it is some ancient wall."

-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_DNLEFT = "Ancient Altar Bottom Left Scrap"
-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_DNLEFT = "Ancient Altar Bottom Left Scrap."
-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_DNLEFT = "Some ancient basis."

-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Ancient Altar Bottom Right Scrap"
-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Ancient Altar Bottom Right Scrap."
-- -- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Some ancient basis."

-- -- Strings.NAMES.ANCIENT_ALTAR_SACK = "Ancient Altar Assembly"
-- -- Strings.RECIPE_DESC.ANCIENT_ALTAR_SACK = "Allows to install Ancient Altar."
-- -- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SACK = "It amazing ancient technology... with magic inside."



-- -- получить список доступных модов
-- function GetModsAll()
	-- if GLOBAL.KnownModIndex and GLOBAL.KnownModIndex.savedata and GLOBAL.KnownModIndex.savedata.known_mods then
		-- local modInfo
		-- local Mods = { Count = 0 }
		
		-- for name,mod in pairs(GLOBAL.KnownModIndex.savedata.known_mods) do
			-- modInfo = GLOBAL.KnownModIndex:GetModInfo(name) -- получим таблицу параметров мода
			-- Mods.Count = Mods.Count + 1;
			-- if GLOBAL.KnownModIndex:IsModEnabled(name) or GLOBAL.KnownModIndex:IsModForceEnabled(name) then
				-- Mods[modInfo.name] = true
			-- else
				-- Mods[modInfo.name] = false
			-- end
		-- end
		
		-- return Mods
	-- else
		-- print("function GetModsAll(): Error in GLOBAL.KnownModIndex!")
	-- end
-- end
-- local allMods = GetModsAll() -- получим таблицу списка модов

-- -- переводим
-- -- если активен мод руссификации
-- if allMods["Russian Language Pack"] then
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_TOP = "Обломок вершины Древней станции"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_TOP = "Обломок вершины Древней станции."
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_TOP = "Возможно это вершина чего-то древнего."
	
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Левый обломок из середины Древней станции"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Левый обломок из середины Древней станции."
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Хммм... Наверное это часть стены."
	
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Правый обломок из середины Древней станции"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Правый обломок из середины Древней станции."
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Hmmm... Наверное это часть стены."
	
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_DNLEFT = "Левый обломок основания Древней станции"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_DNLEFT = "Левый обломок основания Древней станции."
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_DNLEFT = "Похоже на древнее основание."
	
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Правый обломок основания Древней станции"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Правый обломок основания Древней станции."
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Похоже на древнее основание."
	
	-- Strings.NAMES.ANCIENT_ALTAR_SACK = "Сборщик Древней станции"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SACK = "Позволяет установить Древнюю станцию..."
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SACK = "Эта удивительная древняя технология... с магией внутри."
	
-- -- если активен мод перевода китайский
-- elseif allMods["Chinese Language Pack"] or allMods["Traditional Chinese Language Pack"] then
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_TOP = "远古遗迹顶部"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_TOP = "远古遗迹顶部组件"
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_TOP = "也许它是一个古老东西的顶部"
	
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_MIDLEFT = "远古遗迹左中部"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_MIDLEFT = "远古遗迹左中部组件"
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_MIDLEFT = "嗯... 也许它是一些古老的墙"
	
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "远古遗迹右中部"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "远古遗迹右中部组件"
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "嗯... 也许它是一些古老的墙"
	
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_DNLEFT = "远古遗迹左底部"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_DNLEFT = "远古遗迹左底部组件"
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_DNLEFT = "一些古代的地基"
	
	-- Strings.NAMES.ANCIENT_ALTAR_SCRAP_DNRIGHT = "远古遗迹右底部"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SCRAP_DNRIGHT = "远古遗迹右底部组件"
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SCRAP_DNRIGHT = "一些古代的地基"
	
	-- Strings.NAMES.ANCIENT_ALTAR_SACK = "组装远古遗迹"
	-- Strings.RECIPE_DESC.ANCIENT_ALTAR_SACK = "可以建造远古遗迹"
	-- Strings.CHARACTERS.GENERIC.DESCRIBE.ANCIENT_ALTAR_SACK = "它惊人的古老工艺... 暗藏魔法 "
-- end

local UseAncienAltarScrapTop = GetModConfigData("UseAncienAltarScrapTop")
print("UseAncienAltarScrapTop = ", tostring(UseAncienAltarScrapTop))
local UseAncienAltarScrapMidLeft = GetModConfigData("UseAncienAltarScrapMidLeft")
print("UseAncienAltarScrapMidLeft = ", tostring(UseAncienAltarScrapMidLeft))
local UseAncienAltarScrapMidRight = GetModConfigData("UseAncienAltarScrapMidRight")
print("UseAncienAltarScrapMidRight = ", tostring(UseAncienAltarScrapMidRight))
local UseAncienAltarScrapDnLeft = GetModConfigData("UseAncienAltarScrapDnLeft")
print("UseAncienAltarScrapDnLeft = ", tostring(UseAncienAltarScrapDnLeft))
local UseAncienAltarScrapDnRight = GetModConfigData("UseAncienAltarScrapDnRight")
print("UseAncienAltarScrapDnRight = ", tostring(UseAncienAltarScrapDnRight))

-- Recipe = Class(function(self, name, ingredients, tab, level, placer, min_spacing, nounlock, numtogive, builder_tag, atlas, image) -- подсказка по аргументам
-- AddRecipe("ancient_altar_broken", ancientAltarSackIngredient, RecipeTabs.ANCIENT, Tech.NONE, nil, nil, nil, nil, nil, "images/inventory/ancient_altar_sack.xml", "ancient_altar_sack.tex")
-- Recipe("spidereggsack", {Ingredient("silk", 12), Ingredient("spidergland", 6), Ingredient("papyrus", 6)}, RECIPETABS.TOWN, TECH.NONE, nil, nil, nil, nil, "spiderwhisperer")

local thulecitePiecesIngredient = {Ingredient("goldnugget", 6), Ingredient("moonrocknugget", 4), Ingredient("nightmarefuel", 2)}
local thulecitePiecesRecipe = AddRecipe("thulecite_pieces", thulecitePiecesIngredient, RecipeTabs.ANCIENT, Tech.ANCIENT_TWO, nil, nil, true, 2)
thulecitePiecesRecipe.sortkey = 0.01

local countIndgrAncienAltar = 0
local ancientAltarSackIngredient = {}
local indgrAncienAltarScrapTop = Ingredient("ancient_altar_scrap_top", 1, "images/inventory/ancient_altar_scrap_top.xml")
if UseAncienAltarScrapTop then
	local ancientAltarScrapTopIngredient = {Ingredient("thulecite", 1), Ingredient("gears", 1), Ingredient("trinket_6", 1), Ingredient("moonrocknugget", 5), Ingredient("nightmarefuel", 1), Ingredient("livinglog", 1)}
	AddRecipe("ancient_altar_scrap_top", ancientAltarScrapTopIngredient, RecipeTabs.ANCIENT, Tech.ANCIENT_FOUR, nil, nil, true, nil, nil, "images/inventory/ancient_altar_scrap_top.xml")
	countIndgrAncienAltar = countIndgrAncienAltar + 1
	table.insert(ancientAltarSackIngredient, indgrAncienAltarScrapTop)
end

local indgrAncienAltarScrapMidLeft = Ingredient("ancient_altar_scrap_midleft", 1, "images/inventory/ancient_altar_scrap_midleft.xml")
if UseAncienAltarScrapMidLeft then
	local ancientAltarScrapMidLeftIngredient = {Ingredient("thulecite", 1), Ingredient("gears", 1), Ingredient("trinket_6", 1), Ingredient("purplegem", 3), Ingredient("nightmarefuel", 1), Ingredient("livinglog", 1)}
	AddRecipe("ancient_altar_scrap_midleft", ancientAltarScrapMidLeftIngredient, RecipeTabs.ANCIENT, Tech.ANCIENT_FOUR, nil, nil, true, nil, nil, "images/inventory/ancient_altar_scrap_midleft.xml")
	countIndgrAncienAltar = countIndgrAncienAltar + 1
	table.insert(ancientAltarSackIngredient, indgrAncienAltarScrapMidLeft)
end

local indgrAncienAltarScrapMidRight = Ingredient("ancient_altar_scrap_midright", 1, "images/inventory/ancient_altar_scrap_midright.xml")
if UseAncienAltarScrapMidRight then
	local ancientAltarScrapMidRightIngredient = {Ingredient("thulecite", 1), Ingredient("gears", 1), Ingredient("trinket_6", 1), Ingredient("purplegem", 3), Ingredient("nightmarefuel", 1), Ingredient("livinglog", 1)}
	AddRecipe("ancient_altar_scrap_midright", ancientAltarScrapMidRightIngredient, RecipeTabs.ANCIENT, Tech.ANCIENT_FOUR, nil, nil, true, nil, nil, "images/inventory/ancient_altar_scrap_midright.xml")
	countIndgrAncienAltar = countIndgrAncienAltar + 1
	table.insert(ancientAltarSackIngredient, indgrAncienAltarScrapMidRight)
end

local indgrAncienAltarScrapDnLeft = Ingredient("ancient_altar_scrap_dnleft", 1, "images/inventory/ancient_altar_scrap_dnleft.xml")
if UseAncienAltarScrapDnLeft then
	local ancientAltarScrapDnLeftIngredient = {Ingredient("thulecite", 1), Ingredient("gears", 1), Ingredient("trinket_6", 1), Ingredient("orangegem", 3), Ingredient("nightmarefuel", 1), Ingredient("livinglog", 1)}
	AddRecipe("ancient_altar_scrap_dnleft", ancientAltarScrapDnLeftIngredient, RecipeTabs.ANCIENT, Tech.ANCIENT_FOUR, nil, nil, true, nil, nil, "images/inventory/ancient_altar_scrap_dnleft.xml")
	countIndgrAncienAltar = countIndgrAncienAltar + 1
	table.insert(ancientAltarSackIngredient, indgrAncienAltarScrapDnLeft)
end

local indgrAncienAltarScrapDnRight = Ingredient("ancient_altar_scrap_dnright", 1, "images/inventory/ancient_altar_scrap_dnright.xml")
if UseAncienAltarScrapDnRight then
	local ancientAltarScrapDnRightIngredient = {Ingredient("thulecite", 1), Ingredient("gears", 1), Ingredient("trinket_6", 1), Ingredient("yellowgem", 3), Ingredient("nightmarefuel", 1), Ingredient("livinglog", 1)}
	AddRecipe("ancient_altar_scrap_dnright", ancientAltarScrapDnRightIngredient, RecipeTabs.ANCIENT, Tech.ANCIENT_FOUR, nil, nil, true, nil, nil, "images/inventory/ancient_altar_scrap_dnright.xml")
	countIndgrAncienAltar = countIndgrAncienAltar + 1
	table.insert(ancientAltarSackIngredient, indgrAncienAltarScrapDnRight)
end

-- local ancientAltarSackIngredient = {indgrAncienAltarScrapTop, indgrAncienAltarScrapMidLeft, indgrAncienAltarScrapMidRight, indgrAncienAltarScrapDnLeft, indgrAncienAltarScrapDnRight};
if countIndgrAncienAltar>0 then
	AddRecipe("ancient_altar_sack", ancientAltarSackIngredient, RecipeTabs.ANCIENT, Tech.ANCIENT_FOUR, nil, nil, true, nil, nil, "images/inventory/ancient_altar_sack.xml")
else
	ancientAltarSackIngredient = {indgrAncienAltarScrapTop, indgrAncienAltarScrapMidLeft, indgrAncienAltarScrapMidRight, indgrAncienAltarScrapDnLeft, indgrAncienAltarScrapDnRight}
	AddRecipe("ancient_altar_sack", ancientAltarSackIngredient, RecipeTabs.ANCIENT, Tech.MAGIC_THREE, nil, nil, true, nil, nil, "images/inventory/ancient_altar_sack.xml")
end

if GLOBAL.TheNet and GLOBAL.TheNet:GetIsServer() then
	local AncientAltarNewLoot;
	if countIndgrAncienAltar>0 then
		AncientAltarNewLoot = 
		{
			{'orangegem', 1.00},
			{'orangegem', 0.66},
			{'orangegem', 0.33},
			{'yellowgem', 1.00},
			{'yellowgem', 0.66},
			{'yellowgem', 0.33},
			
			{'thulecite', 1.00},
			{'thulecite', 0.88},
			{'thulecite', 0.76},
			{'thulecite', 0.62},
			{'thulecite', 0.38},
			
			-- {'thulecite_pieces', 1.00},
			-- {'thulecite_pieces', 1.00},
			-- {'thulecite_pieces', 0.88},
			-- {'thulecite_pieces', 0.76},
			-- {'thulecite_pieces', 0.62},
			-- {'thulecite_pieces', 0.38},
			-- {'thulecite_pieces', 0.23},
			-- {'thulecite_pieces', 0.12},
			
			{'nightmarefuel', 1.00},
			{'nightmarefuel', 0.62},
			{'nightmarefuel', 0.38},
			{'nightmarefuel', 0.12},
			
			{'livinglog', 1.00},
			{'livinglog', 0.62},
			{'livinglog', 0.38},
			{'livinglog', 0.12},
			
			{'gears', 1.00},
			{'gears', 0.62},
			{'gears', 0.38},
			
			{'trinket_6', 1.00},
			{'trinket_6', 0.76},
			{'trinket_6', 0.50},
			{'trinket_6', 0.38},
			{'trinket_6', 0.24},
			
			{'moonrocknugget', 1.00},
			{'moonrocknugget', 0.38},
		}
	else
		AncientAltarNewLoot = 
		{
			{'ancient_altar_scrap_top', 1.0},
			{'ancient_altar_scrap_midleft', 1.0},
			{'ancient_altar_scrap_midright', 1.0},
			{'ancient_altar_scrap_dnleft', 1.0},
			{'ancient_altar_scrap_dnright', 1.0},
		}
	end
	
	AddPrefabPostInit("ancient_altar_broken", function(inst) inst:DoTaskInTime(0, GLOBAL.SetSharedLootTable("ancient_altar", AncientAltarNewLoot)) end )
end



-- ТЕКСТОВЫЕ ОПИСАНИЯ И ПЕРЕВОД ФРАЗ
local nm = Strings.NAMES
local rec = Strings.RECIPE_DESC
local true_desc = Strings.CHARACTERS.GENERIC.DESCRIBE
local desc = {}
local CLIENT_SIDE = CLIENT_SIDE or TheNet:GetIsClient() or TheNet:GetIsServer() and not TheNet:IsDedicated()
print("Craftable Ancient Altar and Thulecite Pieces: CLIENT_SIDE =", CLIENT_SIDE)


local function GetTranslates(lang, nm, rec, desc, forceLanguage)
	local defLang = GLOBAL.LanguageTranslator.defaultlang
	if defLang~=nil then
		if lang~=defLang and forceLanguage=="def" then
			lang = defLang
		end
	end
	-- print("lang =", lang)
	-- если активен мод руссификации
	if lang=="ru" then
		-- print("useRu")
		nm.ANCIENT_ALTAR_SCRAP_TOP = "Обломок вершины Древней станции"
		rec.ANCIENT_ALTAR_SCRAP_TOP = "Обломок вершины Древней станции."
		desc.ANCIENT_ALTAR_SCRAP_TOP = {}
		desc.ANCIENT_ALTAR_SCRAP_TOP.GENERIC = "Возможно это вершина чего-то древнего."
		desc.ANCIENT_ALTAR_SCRAP_TOP.HELD = "Возможно это вершина чего-то древнего."
		
		nm.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Левый обломок из середины Древней станции"
		rec.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Левый обломок из середины Древней станции."
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT = {}
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT.GENERIC = "Хммм... Наверное это часть стены."
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT.HELD = "Хммм... Наверное это часть стены."
		
		nm.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Правый обломок из середины Древней станции"
		rec.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Правый обломок из середины Древней станции."
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT = {}
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT.GENERIC = "Hmmm... Наверное это часть стены."
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT.HELD = "Hmmm... Наверное это часть стены."
		
		nm.ANCIENT_ALTAR_SCRAP_DNLEFT = "Левый обломок основания Древней станции"
		rec.ANCIENT_ALTAR_SCRAP_DNLEFT = "Левый обломок основания Древней станции."
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT = {}
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT.GENERIC = "Похоже на древнее основание."
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT.HELD = "Похоже на древнее основание."
		
		nm.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Правый обломок основания Древней станции"
		rec.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Правый обломок основания Древней станции."
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT = {}
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT.GENERIC = "Похоже на древнее основание."
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT.HELD = "Похоже на древнее основание."
		
		nm.ANCIENT_ALTAR_SACK = "Сборщик Древней станции"
		rec.ANCIENT_ALTAR_SACK = "Позволяет установить Древнюю станцию..."
		desc.ANCIENT_ALTAR_SACK = {}
		desc.ANCIENT_ALTAR_SACK.GENERIC = "Эта удивительная древняя технология... с магией внутри."
		desc.ANCIENT_ALTAR_SACK.HELD = "Эта удивительная древняя технология... с магией внутри."
		
	-- если активен мод перевода китайский
	elseif lang=="chs" or lang=="cht" then
		-- print("useCh")
		nm.ANCIENT_ALTAR_SCRAP_TOP = "远古遗迹顶部"
		rec.ANCIENT_ALTAR_SCRAP_TOP = "远古遗迹顶部组件"
		desc.ANCIENT_ALTAR_SCRAP_TOP = {}
		desc.ANCIENT_ALTAR_SCRAP_TOP.GENERIC = "也许它是一个古老东西的顶部"
		desc.ANCIENT_ALTAR_SCRAP_TOP.HELD = "也许它是一个古老东西的顶部"
		
		nm.ANCIENT_ALTAR_SCRAP_MIDLEFT = "远古遗迹左中部"
		rec.ANCIENT_ALTAR_SCRAP_MIDLEFT = "远古遗迹左中部组件"
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT = {}
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT.GENERIC = "嗯... 也许它是一些古老的墙"
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT.HELD = "嗯... 也许它是一些古老的墙"
		
		nm.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "远古遗迹右中部"
		rec.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "远古遗迹右中部组件"
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT = {}
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT.GENERIC = "嗯... 也许它是一些古老的墙"
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT.HELD = "嗯... 也许它是一些古老的墙"
		
		nm.ANCIENT_ALTAR_SCRAP_DNLEFT = "远古遗迹左底部"
		rec.ANCIENT_ALTAR_SCRAP_DNLEFT = "远古遗迹左底部组件"
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT = {}
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT.GENERIC = "一些古代的地基"
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT.HELD = "一些古代的地基"
		
		nm.ANCIENT_ALTAR_SCRAP_DNRIGHT = "远古遗迹右底部"
		rec.ANCIENT_ALTAR_SCRAP_DNRIGHT = "远古遗迹右底部组件"
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT = {}
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT.GENERIC = "一些古代的地基"
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT.HELD = "一些古代的地基"
		
		nm.ANCIENT_ALTAR_SACK = "组装远古遗迹"
		rec.ANCIENT_ALTAR_SACK = "可以建造远古遗迹"
		desc.ANCIENT_ALTAR_SACK = {}
		desc.ANCIENT_ALTAR_SACK.GENERIC = "它惊人的古老工艺... 暗藏魔法 "
		desc.ANCIENT_ALTAR_SACK.HELD = "它惊人的古老工艺... 暗藏魔法 "
		
	-- по умолчанию описания на английском языке
	else
		-- print("useEn")
		nm.ANCIENT_ALTAR_SCRAP_TOP = "Ancient Altar Top Scrap"
		rec.ANCIENT_ALTAR_SCRAP_TOP = "Ancient Altar Top Scrap."
		desc.ANCIENT_ALTAR_SCRAP_TOP = {}
		desc.ANCIENT_ALTAR_SCRAP_TOP.GENERIC = "Possibly it is top something ancient."
		desc.ANCIENT_ALTAR_SCRAP_TOP.HELD = "Possibly it is top something ancient."
		
		nm.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Ancient Altar Middle Left Scrap"
		rec.ANCIENT_ALTAR_SCRAP_MIDLEFT = "Ancient Altar Middle Left Scrap."
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT = {}
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT.GENERIC = "Hmmm... Probably it is some ancient wall."
		desc.ANCIENT_ALTAR_SCRAP_MIDLEFT.HELD = "Hmmm... Probably it is some ancient wall."
		
		nm.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Ancient Altar Middle Right Scrap"
		rec.ANCIENT_ALTAR_SCRAP_MIDRIGHT = "Ancient Altar Middle Right Scrap."
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT = {}
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT.GENERIC = "Hmmm... Probably it is some ancient wall."
		desc.ANCIENT_ALTAR_SCRAP_MIDRIGHT.HELD = "Hmmm... Probably it is some ancient wall."
		
		nm.ANCIENT_ALTAR_SCRAP_DNLEFT = "Ancient Altar Bottom Left Scrap"
		rec.ANCIENT_ALTAR_SCRAP_DNLEFT = "Ancient Altar Bottom Left Scrap."
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT = {}
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT.GENERIC = "Some ancient basis."
		desc.ANCIENT_ALTAR_SCRAP_DNLEFT.HELD = "Some ancient basis."
		
		nm.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Ancient Altar Bottom Right Scrap"
		rec.ANCIENT_ALTAR_SCRAP_DNRIGHT = "Ancient Altar Bottom Right Scrap."
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT = {}
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT.GENERIC = "Some ancient basis."
		desc.ANCIENT_ALTAR_SCRAP_DNRIGHT.HELD = "Some ancient basis."
		
		nm.ANCIENT_ALTAR_SACK = "Ancient Altar Assembly"
		rec.ANCIENT_ALTAR_SACK = "Allows to install Ancient Altar."
		desc.ANCIENT_ALTAR_SACK = {}
		desc.ANCIENT_ALTAR_SACK.GENERIC = "It amazing ancient technology... with magic inside."
		desc.ANCIENT_ALTAR_SACK.HELD = "It amazing ancient technology... with magic inside."
	end
end

function Translate()
	-- print("Перевод фраз на клиенте")
	local forceLanguage = GLOBAL.CRAFTABLEANCIENTALTAR_FORCELANGUAGE
	local lang = GLOBAL.LanguageTranslator.defaultlang
	-- print("Определёно: lang = ", lang, "; forceLanguage = ", forceLanguage)
	if lang~=nil then
		local SupportedLangs = { en=1, chs=1, cht="chs", TW="chs", ru=1, } -- 1 указывает на существование файла, строка переводит на другой языковый файл.
		local sign = SupportedLangs[lang]
		-- print("Определёно существование перевода:", tostring(sign))
		if sign~=1 then
			lang = sign -- Если nil, то просто отключаем. Если переадресация, то указывается новый язык.
		end
		if forceLanguage~="def" then
			lang = forceLanguage
		end
		if sign~=nil then
			speech_tbl = {}
			function AddSpeech(orig, val) -- val can't be nil
				if orig==nil or val=="" then return end -- no empty strings
				speech_tbl[orig] = val
				-- print("Замена ", tostring(orig), " на ", tostring(val))
			end
			local function TranslateTo(message) -- Возвращает перевод или nil в случае отсутствия.
				-- Умная функция отбрасывает всё после \n, а потом снова склеивает с хвостом.
				if message and type(message)=="string" then
					local find_n = string.find(message, "\n", 1, true)
					local cut_mess = find_n==nil and message or message:sub(1, find_n-1)
					if speech_tbl[cut_mess] then
						return find_n==nil and speech_tbl[cut_mess] or speech_tbl[cut_mess] .. message:sub(find_n)
					end
				end
			end
			-- перевод на произносимого на сервере. В смысле, на хосте, но без пересылки по сети клиентам.
			if TheNet.Talker then
				GLOBAL.getmetatable(TheNet).__index.Talker = (function()
					local oldTalker = GLOBAL.getmetatable(TheNet).__index.Talker
					return function(self, message, entity, ...)
						-- print("Перевод на произносимого на сервере: message = ", message)
						-- print("oldTalker =", tostring(message))
						oldTalker(self, message, entity, ...)
						-- print("entity =", tostring(entity))
						local inst = entity and entity:GetGUID() or nil
						inst = inst and GLOBAL.Ents[inst] or nil -- определяем инстанс персонажа по entity
						-- print("inst =",tostring(inst))
						if inst and inst.components.talker.widget  then -- если он может говорить
							message = TranslateTo(message)
							if message and type(message)=="string" then
								-- print("Trans =", tostring(message))
								inst.components.talker.widget.text:SetString(message) -- меняем текст
							end
						end
					end
				end)()
			end
			-- перевод сообщения на стороне клиента
			if GLOBAL.rawget(GLOBAL,"Networking_Talk") then
				local OldNetworking_Talk = GLOBAL.Networking_Talk
				function Networking_Talk(guid, message, ...)
					-- print("Перевод на произносимого на стороне клиента: message = ", message)
					-- local entity = GLOBAL.Ents[guid]
					-- message=t.TranslateTo(message,entity) or message --Переводим на русский
					message = TranslateTo(message) or message
					OldNetworking_Talk(guid, message, ...)
				end
				GLOBAL.Networking_Talk = Networking_Talk
			end
			-- print("Craftable Ancient Altar and Thulecite Pieces Detected language:", lang")
			-- desc = {} -- Скрываем реальные константы, т.к. на сервере они не нужны. А на клиенте будет функция. --!!!TODO
			GetTranslates(lang, nm, rec, desc, forceLanguage)
			-- print("Structure desc and replace:")
			for k,v in pairs(desc) do -- for k,v in pairs(desc) do Добавляем реплики
				-- msg = "k = " .. tostring(k) .. "; v = " .. tostring(v) .. "; true_desc[k] = " .. tostring(true_desc[k])
				-- print(msg)
				AddSpeech(true_desc[k], v)
			end
			-- print("Structure speech_tbl:")
			-- for k,v in pairs(speech_tbl) do
				-- msg = "k = " .. tostring(k) .. "; v = " .. tostring(v)
				-- print(msg)
			-- end
		end
	end
end

-- переведём текст на язык по умолчанию на стороне сервера
if not (GLOBAL.KnownModIndex and GLOBAL.KnownModIndex.savedata and GLOBAL.KnownModIndex.savedata.known_mods) then
	print("Craftable Ancient Altar and Thulecite Pieces: Can't find KnownModIndex!")
	return
end
local useLanguage = "en"
print("Craftable Ancient Altar and Thulecite Pieces: useLanguage==", useLanguage) -- , " по умолчанию")

if GLOBAL.CRAFTABLEANCIENTALTAR_FORCELANGUAGE=="def" then
	-- print("Craftable Ancient Altar and Thulecite Pieces: useLanguage==", useLanguage, " после определения языка")
	GetTranslates(useLanguage, nm, rec, true_desc, useLanguage) -- по умолчанию грузим английский перевод
else
	-- print("Craftable Ancient Altar and Thulecite Pieces: useLanguage==", useLanguage, " после определения языка")
	GetTranslates(GLOBAL.CRAFTABLEANCIENTALTAR_FORCELANGUAGE, nm, rec, true_desc, useLanguage) -- грузим принудительный перевод
end

-- переводим фразы
if CLIENT_SIDE then AddPrefabPostInit("world", Translate, GLOBAL.CRAFTABLEANCIENTALTAR_FORCELANGUAGE) end